package usherbrooke.ift630;

public class App {
	static private int numLines				= 3;
	static private int numBusPerLine		= 2;
	static private int numBusses			= numLines * numBusPerLine;
	static private int numStopPerBus		= 8;
	static private int numStops				= numBusses * numStopPerBus;
	static private int numPassengersPerBus	= 5;
	static private int numPassengersPerStop = 5;
	//static private int numPassengers		= numPassengersPerStop * numStops;
	static private int numThreadsBus		= 5;
	static private int numThreadsStop		= 2;
	static private int timeBetweenStops 	= 5;
	static private int timeEmbark			= 2;
	static private int socketPort			= 8181;

	public static void main(String[] args) {
		try {
			if (numStopPerBus > numStops) {
				System.out.println("More stops per bus than stops.");
				return;
			}

			Central central = new Central(numThreadsBus, numThreadsStop, socketPort);
			// create everything
			central.createStops(numStops, numPassengersPerStop);
			central.createLines(numLines, numStopPerBus, numStops);
			central.createBusses(numBusses, timeBetweenStops, timeEmbark, numPassengersPerBus);
			central.createPassengers(numPassengersPerStop, numStopPerBus);

			// print start details
			System.out.println("-----".repeat(5) + " START " + "-----".repeat(5));
			central.printDetails();
			System.out.println("-----".repeat(5) + " START " + "-----".repeat(5));

			// start bus thread
			central.startBusThreads();

			// shutdown and wait!
			central.shutdown();
		} catch (Exception e) {
			System.out.println("[APP] " + e.toString());
		}
	}
}
