package usherbrooke.ift630;

import java.util.List;
import java.util.ArrayList;

class Line {
	private List<Stop> stops;
	private String name;
	private int id;

	Line(int id, ArrayList<Stop> stops) {
		this.id = id;
		this.name = "Line " + this.id;
		this.stops = stops;
	}

	// get stops from index
	public List<Stop> getStops(int index) {
		return stops.subList(index, stops.size() - 1);
	}

	public List<Stop> getStops() {
		return stops;
	}

	public String getName() {
		return name;
	}

	public void printDetails() {
		printDetails(0);
	}

	public void printDetails(int indent) {
		Logger.getInstance().print(id, "\t.".repeat(indent) + "[TRIP] " + name);
		for (Stop s : stops) {
			s.printDetails(id, indent + 1);
		}
	}

	public Stop get(int idx) {
		return stops.get(idx);
	}

	public int getId() {
		return id;
	}

	public Stop getTerminus() {
		return stops.get(stops.size() - 1);
	}
}
